## gce-compute-image-packages 20170622

=== google_compute_engine_oslogin/Makefile ===
SHELL = /bin/sh

BASENAME = oslogin
NAME = google-compute-engine-$(BASENAME)
MAJOR = 1
MINOR = 0
REVISION = 0

NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2
NSS_INSTALL_PATH = /lib
PAM_INSTALL_PATH = /lib/security
AUTHKEYS_INSTALL_PATH = /usr/bin

CXX = g++
CXXFLAGS += -fPIC# -Wall
PAMFLAGS = $(LDFLAGS) -shared
NSSFLAGS = $(LDFLAGS) -shared -Wl,-soname,$(NSS_LIBRARY_SONAME)

# UTILS
UTILS_DIR = utils
UTILS_SRC = $(UTILS_DIR)/$(BASENAME)_utils.cc
UTILS = $(UTILS_DIR)/$(BASENAME)_utils.o

# AUTHORIZED KEYS
AUTHKEYS_DIR = authorized_keys
AUTHKEYS_SRC = $(AUTHKEYS_DIR)/authorized_keys.cc
AUTHKEYS_BIN = google_authorized_keys

# NSS
NSS = nss_$(BASENAME)
NSS_DIR = nss_module
NSS_SRC = $(NSS_DIR)/$(NSS).cc

# PAM
PAM = pam_$(BASENAME)
PAM_DIR = pam_module
PAM_ADMIN = $(PAM)_admin
PAM_ADMIN_SRC = $(PAM_DIR)/$(PAM_ADMIN).cc
PAM_ADMIN_OBJ = $(PAM_DIR)/$(PAM_ADMIN).o
PAM_ADMIN_MOD = $(PAM_ADMIN).so
PAM_LOGIN = $(PAM)_login
PAM_LOGIN_SRC = $(PAM_DIR)/$(PAM_LOGIN).cc
PAM_LOGIN_OBJ = $(PAM_DIR)/$(PAM_LOGIN).o
PAM_LOGIN_MOD = $(PAM_LOGIN).so

# HELPER SCRIPTS
BIN_DIR = bin
OSLOGIN_HELPER = $(BIN_DIR)/google_oslogin_control
BIN_INSTALL_PATH = /usr/bin

# SELINUX POLICY
INSTALL_SELINUX =
POLICY_DIR = policy
SELINUX_MODULE = $(POLICY_DIR)/oslogin$(DIST).pp
SELINUX_INSTALL_NAME = oslogin.pp
SELINUX_INSTALL_PATH = /usr/share/selinux/packages

LIBS = -lcurl -ljson-c
PAM_LIBS = -lpam $(LIBS)

all: $(NSS) $(PAM) $(AUTHKEYS_BIN)

$(NSS): $(NSS_LIBRARY_SOURCE) $(UTILS)
	$(CXX) $(CXXFLAGS) $(NSSFLAGS) -o $(NSS_LIBRARY_NAME) \
	$(NSS_SRC) $(UTILS) $(LIBS)

$(PAM): $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD)

$(PAM_LOGIN_MOD): $(PAM_LOGIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_LOGIN_MOD) $(PAM_LOGIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_ADMIN_MOD): $(PAM_ADMIN_OBJ) $(UTILS)
	$(CXX) $(PAMFLAGS) -o $(PAM_ADMIN_MOD) $(PAM_ADMIN_OBJ) $(UTILS) $(PAM_LIBS)

$(PAM_LOGIN_OBJ): $(PAM_LOGIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_LOGIN_SRC) -o $(PAM_LOGIN_OBJ)

$(PAM_ADMIN_OBJ): $(PAM_ADMIN_SRC)
	$(CXX) $(CXXFLAGS) -c $(PAM_ADMIN_SRC) -o $(PAM_ADMIN_OBJ)

$(AUTHKEYS_BIN): $(AUTHKEYS_SRC) $(UTILS_SRC)
	$(CXX) $(LDFLAGS) -o $(AUTHKEYS_BIN) $(AUTHKEYS_SRC) $(UTILS_SRC) $(LIBS)

$(UTILS): $(UTILS_SRC)
	$(CXX) $(CXXFLAGS) -c $(UTILS_SRC) -o $(UTILS)

install: $(NSS_LIBRARY_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)
	mkdir -p $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)
	mkdir -p $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)
	install -m 0644 $(NSS_LIBRARY_NAME) $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)
	install -m 0644 $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)
	install -m 0755 $(AUTHKEYS_BIN) $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)
	install -m 0755 $(OSLOGIN_HELPER) $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)
ifdef INSTALL_SELINUX
	mkdir -p $(DESTDIR)$(PREFIX)$(SELINUX_INSTALL_PATH)
	install -T -m 0644 $(SELINUX_MODULE) $(DESTDIR)$(PREFIX)$(SELINUX_INSTALL_PATH)/$(SELINUX_INSTALL_NAME)
endif

uninstall:
	rm -f $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)/$(NSS_LIBRARY_NAME)
	rm -f $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)/$(PAM_ADMIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)/$(PAM_LOGIN_MOD)
	rm -f $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)/$(AUTHKEYS_BIN)
	rm -f $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)/$(OSLOGIN_HELPER)
clean:
	rm -f $(UTILS) $(NSS_LIBRARY_NAME) $(PAM_ADMIN_OBJ) $(PAM_ADMIN_MOD) $(PAM_LOGIN_OBJ) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)

## gce-compute-image-packages 20160930

=== debian/changelog ===
gce-compute-image-packages (20160930-0ubuntu6~16.04.0) xenial; urgency=medium

  * Backport to xenial.

 -- Phil Roche <phil.roche@canonical.com>  Mon, 20 Mar 2017 15:01:51 +0000

gce-compute-image-packages (20160930-0ubuntu6~16.10.0) yakkety; urgency=medium

  * Backport to yakkety.

 -- Phil Roche <phil.roche@canonical.com>  Mon, 20 Mar 2017 14:55:51 +0000

gce-compute-image-packages (20160930-0ubuntu6) zesty; urgency=medium

  * Do not restart startup or shutdown scripts on upgrade (LP: #1668327)

 -- Phil Roche <phil.roche@canonical.com>  Mon, 20 Mar 2017 14:47:51 +0000

gce-compute-image-packages (20160930-0ubuntu5~16.04.0) xenial; urgency=medium

  * Backport to xenial.

 -- Daniel Watkins <daniel.watkins@canonical.com>  Wed, 15 Feb 2017 13:07:36 +0000

gce-compute-image-packages (20160930-0ubuntu5) zesty; urgency=medium

  * Install upstream-provided rsyslog configuration so that daemons can log to
    the serial console. (LP: #1664949)

 -- Daniel Watkins <daniel.watkins@canonical.com>  Wed, 15 Feb 2017 11:40:12 +0000

gce-compute-image-packages (20160930-0ubuntu4) zesty; urgency=medium

  * Reintroduce udev rules that configure GCE-specific behaviour.
    (LP: #1662491)

 -- Daniel Watkins <daniel.watkins@canonical.com>  Mon, 06 Feb 2017 16:22:37 +0000

gce-compute-image-packages (20160930-0ubuntu3~16.04.1) xenial; urgency=medium

  * Reintroduce udev rules that configure GCE-specific behaviour.
    (LP: #1662491)

 -- Daniel Watkins <daniel.watkins@canonical.com>  Mon, 06 Feb 2017 16:22:37 +0000

gce-compute-image-packages (20160930-0ubuntu3~16.04.0) xenial; urgency=medium

  * Backport gce-compute-image-packages to xenial (LP: #1643585)

 -- Phil Roche <phil.roche@canonical.com>  Thu, 25 Nov 2016 14:01:00 +0000

gce-compute-image-packages (20160930-0ubuntu3) zesty; urgency=medium

  * GCE mirrors not in place before startup scripts are run (LP: #1436846)
  * Run google-startup-scripts.service after multi-user.target (LP: #1627436)

 -- Phil Roche <phil.roche@canonical.com>  Thu, 17 Nov 2016 15:09:00 +0000

gce-compute-image-packages (20160930-0ubuntu2) yakkety; urgency=medium

  * Document all elements of the source package in debian/copyright.
  * Add Replaces: for our Conflicts: to ensure replacement.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Oct 2016 23:35:49 -0700

gce-compute-image-packages (20160930-0ubuntu1) yakkety; urgency=medium

  * New upstream release.

 -- Daniel Watkins <daniel.watkins@canonical.com>  Fri, 30 Sep 2016 15:27:56 -0700

gce-compute-image-packages (20160826-0ubuntu1) yakkety; urgency=medium

  * Initial release. (LP: #1613677)

 -- Daniel Watkins <daniel.watkins@canonical.com>  Tue, 20 Sep 2016 11:44:25 +0100

=== debian/control ===
Source: gce-compute-image-packages
Section: admin
Priority: extra
Maintainer: Daniel Watkins <daniel.watkins@canonical.com>
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd,
               python-all,
               python-setuptools,
               python3-all,
               python3-setuptools,
               python-pytest,
               python3-pytest,
               python-mock,
               python-boto,
               python3-boto
Standards-Version: 3.9.8
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages

Package: gce-compute-image-packages
Architecture: all
Depends: python3:any,
         ${python3:Depends},
         ${misc:Depends},
         python3-google-compute-engine,
         ntp,
         cloud-init
Recommends: google-cloud-sdk,
            libpam-cracklib
Conflicts: gce-cloud-config,
        gce-daemon,
        gce-startup-scripts
Replaces: gce-cloud-config,
          gce-daemon,
          gce-startup-scripts
Description: GCE's compute-image-packages for use in their guest environment
 This is a collection of scripts that are used on Google Compute Engine images
 to ensure compatibility with the cloud, as well as to enable features specific
 to the cloud.

Package: python-google-compute-engine
Section: python
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
Description: Python library for Google Compute Engine interaction
 Python libraries used for interacting with Google Compute Engine's APIs and
 functionality.  This package contains the modules for Python 2.x.

Package: python3-google-compute-engine
Section: python
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
Description: Python library for Google Compute Engine interaction (Python 3)
 Python libraries used for interacting with Google Compute Engine's APIs and
 functionality.  This package contains the modules for Python 3.x.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

%:
	dh $@ --with python2,python3,systemd --buildsystem=pybuild

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-startup-scripts
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-shutdown-scripts

override_dh_python3:
	dh_python3
	
	# We want to split the Python 3 scripts out to the
	# gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python3-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python3-google-compute-engine/usr/bin

override_dh_python2:
	dh_python2

	# We don't want the Python 2 scripts at all
	rm -rf debian/python-google-compute-engine/usr/bin

override_dh_clean:
	rm -rf google_compute_engine.egg-info
	dh_clean

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gce-compute-image-packages-$1\.tar\.gz/" \
  https://github.com/GoogleCloudPlatform/compute-image-packages/tags .*/v?(\d\S*)\.tar\.gz

## gce-compute-image-packages 20170426

=== debian/changelog ===
gce-compute-image-packages (20170426-0ubuntu2~14.04.0) trusty; urgency=medium

  * Backport to trusty.
    - Retain the delta between devel and trusty as those are necessary for the
      package to build and work.
  * debian/control:
    - Make the python3-google-compute-engine dependency versioned for
      gce-compute-image-packages always on the most current version
      (LP: #1690147).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 11 May 2017 16:00:46 +0200

gce-compute-image-packages (20170426-0ubuntu1) artful; urgency=medium

  * New upstream release (LP: #1689205).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 05 May 2017 09:42:01 +0200

=== debian/control ===
Source: gce-compute-image-packages
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Watkins <daniel.watkins@canonical.com>
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd,
               python-all,
               python-setuptools,
               python-pytest,
               python-mock,
               python-boto
Standards-Version: 3.9.8
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages

Package: gce-compute-image-packages
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         python-google-compute-engine (= ${source:Version}),
         ntp,
         cloud-init
Recommends: google-cloud-sdk,
            libpam-cracklib
Conflicts: gce-cloud-config,
        gce-daemon,
        gce-startup-scripts
Replaces: gce-cloud-config,
          gce-daemon,
          gce-startup-scripts
Description: GCE's compute-image-packages for use in their guest environment
 This is a collection of scripts that are used on Google Compute Engine images
 to ensure compatibility with the cloud, as well as to enable features specific
 to the cloud.

Package: python-google-compute-engine
Section: python
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
Description: Python library for Google Compute Engine interaction
 Python libraries used for interacting with Google Compute Engine's APIs and
 functionality.  This package contains the modules for Python 2.x.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

%:
	dh $@ --with python2,systemd --buildsystem=pybuild

override_dh_installinit:
	dh_installinit --name=google-startup-scripts --onlyscripts --no-start --no-restart-on-upgrade 
	dh_installinit --name=google-shutdown-scripts --onlyscripts --no-start --no-restart-on-upgrade
	dh_installinit --name=google-shutdown-scripts-block-rsyslog --onlyscripts --no-start --no-restart-on-upgrade

override_dh_clean:
	rm -rf google_compute_engine.egg-info
	dh_clean

override_dh_python2:
	dh_python2

    # We want to split the Python scripts out to the
    # gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python-google-compute-engine/usr/bin

## gce-compute-image-packages 20170523

=== debian/changelog ===
gce-compute-image-packages (20170523-0ubuntu1~17.04.0) zesty; urgency=medium

  * Backport to zesty.
  * New upstream release (LP: #1696191).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Tue, 06 Jun 2017 09:50:59 -0700

gce-compute-image-packages (20170426-0ubuntu2) artful; urgency=medium

  * debian/control:
    - Make the python3-google-compute-engine dependency versioned for
      gce-compute-image-packages always on the most current version
      (LP: #1690147).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Thu, 11 May 2017 14:25:24 +0200

=== debian/control ===
--- 
+++ 
@@ -8,17 +8,22 @@
                dh-systemd,
                python-all,
                python-setuptools,
+               python3-all,
+               python3-setuptools,
                python-pytest,
+               python3-pytest,
                python-mock,
-               python-boto
+               python-boto,
+               python3-boto
 Standards-Version: 3.9.8
 Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages
 
 Package: gce-compute-image-packages
 Architecture: all
-Depends: ${python:Depends},
+Depends: python3:any,
+         ${python3:Depends},
          ${misc:Depends},
-         python-google-compute-engine (= ${source:Version}),
+         python3-google-compute-engine (= ${source:Version}),
          ntp,
          cloud-init
 Recommends: google-cloud-sdk,
@@ -42,3 +47,12 @@
 Description: Python library for Google Compute Engine interaction
  Python libraries used for interacting with Google Compute Engine's APIs and
  functionality.  This package contains the modules for Python 2.x.
+
+Package: python3-google-compute-engine
+Section: python
+Architecture: all
+Depends: ${python3:Depends},
+         ${misc:Depends},
+Description: Python library for Google Compute Engine interaction (Python 3)
+ Python libraries used for interacting with Google Compute Engine's APIs and
+ functionality.  This package contains the modules for Python 3.x.

## gce-compute-image-packages 20170609

=== debian/changelog ===
gce-compute-image-packages (20170609-0ubuntu1) artful; urgency=medium

  * Fix empty lines in debian/rules
  * Update copyright years
  * New upstream version 20170609 (LP: #1699105)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 20 Jun 2017 13:06:49 +0200

gce-compute-image-packages (20170523-0ubuntu1) artful; urgency=medium

  * New upstream release (LP: #1696191).

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Tue, 06 Jun 2017 09:50:59 -0700

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

%:
	dh $@ --with python2,python3,systemd --buildsystem=pybuild

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-startup-scripts
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-shutdown-scripts

override_dh_python3:
	dh_python3
	# We want to split the Python 3 scripts out to the
	# gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python3-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python3-google-compute-engine/usr/bin

override_dh_python2:
	dh_python2
	# We don't want the Python 2 scripts at all
	rm -rf debian/python-google-compute-engine/usr/bin

override_dh_clean:
	rm -rf google_compute_engine.egg-info
	dh_clean

## gce-compute-image-packages 20170622

=== debian/changelog ===
gce-compute-image-packages (20170622-0ubuntu1~14.04.1) trusty; urgency=medium

  * Fix installation of google-compute-engine-oslogin (LP: #1703647)
    using patch cherry-picked from upstream

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 11 Jul 2017 19:00:07 +0200

gce-compute-image-packages (20170622-0ubuntu1~14.04.0) trusty; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to trusty.
    - Retain the delta between devel and trusty as those are necessary for the
      package to build and work.

  [ Balint Reczey ]
  * New upstream version 20170622 (LP: #1700027)
    - Add Linux guest environment support for OS Login
  * Add google-compute-engine-oslogin binary package (LP: #1694571)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 23 Jun 2017 10:42:27 +0200

=== debian/control ===
Source: gce-compute-image-packages
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Watkins <daniel.watkins@canonical.com>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               dh-systemd,
               libcurl4-openssl-dev,
               libgtest-dev,
               libjson-c-dev,
               libpam-dev,
               python-all,
               python-setuptools,
               python-pytest,
               python-mock,
               python-boto
Standards-Version: 3.9.8
Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages

Package: gce-compute-image-packages
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         python-google-compute-engine (= ${source:Version}),
         ntp,
         cloud-init
Recommends: google-cloud-sdk,
            libpam-cracklib
Conflicts: gce-cloud-config,
        gce-daemon,
        gce-startup-scripts
Replaces: gce-cloud-config,
          gce-daemon,
          gce-startup-scripts
Description: GCE's compute-image-packages for use in their guest environment
 This is a collection of scripts that are used on Google Compute Engine images
 to ensure compatibility with the cloud, as well as to enable features specific
 to the cloud.

Package: python-google-compute-engine
Section: python
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
Description: Python library for Google Compute Engine interaction
 Python libraries used for interacting with Google Compute Engine's APIs and
 functionality.  This package contains the modules for Python 2.x.

Package: google-compute-engine-oslogin
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Google Compute Engine OS Login
 Contains libraries, applications and configurations for using OS Login
 on Google Compute Engine Virtual Machine Instances.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

OSLOGIN_DIR=google_compute_engine_oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,systemd --buildsystem=pybuild

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	(cd $(OSLOGIN_DIR)/utils && \
		$(CXX) $(CXXFLAGS) -L../../gtest -o test_runner oslogin_utils_test.cc oslogin_utils.cc -lcurl -ljson-c -lgtest -lpthread && \
		./test_runner && \
		rm test_runner)

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	$(MAKE) -C $(OSLOGIN_DIR) DESTDIR=$(CURDIR)/debian/tmp PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security BIN_INSTALL_PATH=/usr/bin install

override_dh_installinit:
	dh_installinit --name=google-startup-scripts --onlyscripts --no-start --no-restart-on-upgrade 
	dh_installinit --name=google-shutdown-scripts --onlyscripts --no-start --no-restart-on-upgrade
	dh_installinit --name=google-shutdown-scripts-block-rsyslog --onlyscripts --no-start --no-restart-on-upgrade

override_dh_clean:
	rm -rf google_compute_engine.egg-info gtest
	dh_clean

override_dh_python2:
	dh_python2

    # We want to split the Python scripts out to the
    # gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python-google-compute-engine/usr/bin

## gce-compute-image-packages 20170718

=== debian/changelog ===
gce-compute-image-packages (20170718-0ubuntu1~17.04.0) zesty; urgency=medium

  [ Balint Reczey ]
  * Update debian/copyright
  * New upstream version 20170718 (LP: #1705448)

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to zesty.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 21 Jul 2017 09:25:56 +0200

gce-compute-image-packages (20170622-0ubuntu1) artful; urgency=medium

  * New upstream version 20170622 (LP: #1700027)
    - Add Linux guest environment support for OS Login
  * Add google-compute-engine-oslogin binary package (LP: #1694571)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 23 Jun 2017 10:42:27 +0200

## gce-compute-image-packages 20170921+dfsg1

=== debian/changelog ===
gce-compute-image-packages (20170921+dfsg1-0ubuntu1~14.04.0) trusty; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to xenial (LP: #1718922).
    - Retain the delta between devel and trusty as those are necessary for the
      package to build and work.

  [ Balint Reczey ]
  * New upstream version 20170921+dfsg1
  * Exclude upstream's debian/ directory to not interact with packaging
  * Repack orig source with +dfsg1 suffix
  * Ship sysctl configuration for Google-recommended kernel parameters
  * Update symlink to shared library with updated patch version
  * Make google-compute-engine-oslogin depend on openssh-server

  [ Google Cloud Team ]
  * Add DHCP exit hook script back into package.
  * Ship systemd preset

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 22 Sep 2017 01:35:35 +0200

gce-compute-image-packages (20170718-0ubuntu1) artful; urgency=medium

  * Update debian/copyright
  * New upstream version 20170718 (LP: #1705448)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 20 Jul 2017 14:28:58 +0200

=== debian/control ===
--- 
+++ 
@@ -51,7 +51,8 @@
 Package: google-compute-engine-oslogin
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         openssh-server
 Description: Google Compute Engine OS Login
  Contains libraries, applications and configurations for using OS Login
  on Google Compute Engine Virtual Machine Instances.

## gce-compute-image-packages 20171006+dfsg1

=== google_compute_engine_oslogin/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 NAME = google-compute-engine-$(BASENAME)
 MAJOR = 1
 MINOR = 0
-REVISION = 0
+REVISION = 5
 
 NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
 NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2
@@ -52,6 +52,8 @@
 # SELINUX POLICY
 INSTALL_SELINUX =
 POLICY_DIR = policy
+SELINUX_MODULE_SRC = $(POLICY_DIR)/oslogin$(DIST).te
+SELINUX_MOD_FILE = $(POLICY_DIR)/oslogin$(DIST).mod
 SELINUX_MODULE = $(POLICY_DIR)/oslogin$(DIST).pp
 SELINUX_INSTALL_NAME = oslogin.pp
 SELINUX_INSTALL_PATH = /usr/share/selinux/packages
@@ -59,7 +61,11 @@
 LIBS = -lcurl -ljson-c
 PAM_LIBS = -lpam $(LIBS)
 
+ifdef INSTALL_SELINUX
+all: $(NSS) $(PAM) $(AUTHKEYS_BIN) $(SELINUX_MODULE)
+else
 all: $(NSS) $(PAM) $(AUTHKEYS_BIN)
+endif
 
 $(NSS): $(NSS_LIBRARY_SOURCE) $(UTILS)
 	$(CXX) $(CXXFLAGS) $(NSSFLAGS) -o $(NSS_LIBRARY_NAME) \
@@ -85,26 +91,37 @@
 $(UTILS): $(UTILS_SRC)
 	$(CXX) $(CXXFLAGS) -c $(UTILS_SRC) -o $(UTILS)
 
+$(SELINUX_MOD_FILE): $(SELINUX_MODULE_SRC)
+	checkmodule -M -m -o $(SELINUX_MOD_FILE) $(SELINUX_MODULE_SRC)
+
+$(SELINUX_MODULE): $(SELINUX_MOD_FILE)
+	semodule_package -o $(SELINUX_MODULE) -m  $(SELINUX_MOD_FILE)
+
+
+ifdef INSTALL_SELINUX
+install: $(NSS_LIBRARY_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN) $(SELINUX_MODULE)
+else
 install: $(NSS_LIBRARY_NAME) $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)
-	mkdir -p $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)
-	mkdir -p $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)
-	mkdir -p $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)
-	mkdir -p $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)
-	install -m 0644 $(NSS_LIBRARY_NAME) $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)
-	install -m 0644 $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)
-	install -m 0755 $(AUTHKEYS_BIN) $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)
-	install -m 0755 $(OSLOGIN_HELPER) $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)
+endif
+	mkdir -p $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
+	mkdir -p $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
+	mkdir -p $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
+	mkdir -p $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
+	install -m 0644 $(NSS_LIBRARY_NAME) $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)
+	install -m 0644 $(PAM_ADMIN_MOD) $(PAM_LOGIN_MOD) $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)
+	install -m 0755 $(AUTHKEYS_BIN) $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)
+	install -m 0755 $(OSLOGIN_HELPER) $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)
 ifdef INSTALL_SELINUX
-	mkdir -p $(DESTDIR)$(PREFIX)$(SELINUX_INSTALL_PATH)
-	install -T -m 0644 $(SELINUX_MODULE) $(DESTDIR)$(PREFIX)$(SELINUX_INSTALL_PATH)/$(SELINUX_INSTALL_NAME)
+	mkdir -p $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)
+	install -T -m 0644 $(SELINUX_MODULE) $(DESTDIR)$(PREFIX)/$(SELINUX_INSTALL_PATH)/$(SELINUX_INSTALL_NAME)
 endif
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)$(NSS_INSTALL_PATH)/$(NSS_LIBRARY_NAME)
-	rm -f $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)/$(PAM_ADMIN_MOD)
-	rm -f $(DESTDIR)$(PREFIX)$(PAM_INSTALL_PATH)/$(PAM_LOGIN_MOD)
-	rm -f $(DESTDIR)$(PREFIX)$(AUTHKEYS_INSTALL_PATH)/$(AUTHKEYS_BIN)
-	rm -f $(DESTDIR)$(PREFIX)$(BIN_INSTALL_PATH)/$(OSLOGIN_HELPER)
+	rm -f $(DESTDIR)$(PREFIX)/$(NSS_INSTALL_PATH)/$(NSS_LIBRARY_NAME)
+	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_ADMIN_MOD)
+	rm -f $(DESTDIR)$(PREFIX)/$(PAM_INSTALL_PATH)/$(PAM_LOGIN_MOD)
+	rm -f $(DESTDIR)$(PREFIX)/$(AUTHKEYS_INSTALL_PATH)/$(AUTHKEYS_BIN)
+	rm -f $(DESTDIR)$(PREFIX)/$(BIN_INSTALL_PATH)/$(OSLOGIN_HELPER)
 clean:
 	rm -f $(UTILS) $(NSS_LIBRARY_NAME) $(PAM_ADMIN_OBJ) $(PAM_ADMIN_MOD) $(PAM_LOGIN_OBJ) $(PAM_LOGIN_MOD) $(AUTHKEYS_BIN)

=== debian/changelog ===
gce-compute-image-packages (20171006+dfsg1-0ubuntu1~16.04.0) xenial; urgency=medium

  [ Balint Reczey ]
  * List current packaging repository in debian/control
  * New upstream version 20171006+dfsg1 (LP: #1722356)
    - Fix system hang during VM shutdown
    - JSON parser accepts string types for int64 values
  * Update symlink to shared library with updated patch version

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to xenial.

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 09 Oct 2017 19:16:04 +0200

gce-compute-image-packages (20170921+dfsg1-0ubuntu1) artful; urgency=medium

  [ Balint Reczey ]
  * New upstream version 20170921+dfsg1
  * Exclude upstream's debian/ directory to not interact with packaging
  * Repack orig source with +dfsg1 suffix
  * Ship sysctl configuration for Google-recommended kernel parameters
  * Update symlink to shared library with updated patch version
  * Make google-compute-engine-oslogin depend on openssh-server

  [ Google Cloud Team ]
  * Add DHCP exit hook script back into package.
  * Ship systemd preset

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 22 Sep 2017 01:35:35 +0200

=== debian/control ===
--- 
+++ 
@@ -13,17 +13,24 @@
                libpam-dev,
                python-all,
                python-setuptools,
+               python3-all,
+               python3-setuptools,
                python-pytest,
+               python3-pytest,
                python-mock,
-               python-boto
+               python-boto,
+               python3-boto
 Standards-Version: 3.9.8
 Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages
+Vcs-Git: git://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
+Vcs-Browser: https://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
 
 Package: gce-compute-image-packages
 Architecture: all
-Depends: ${python:Depends},
+Depends: python3:any,
+         ${python3:Depends},
          ${misc:Depends},
-         python-google-compute-engine (= ${source:Version}),
+         python3-google-compute-engine (= ${source:Version}),
          ntp,
          cloud-init
 Recommends: google-cloud-sdk,
@@ -48,6 +55,15 @@
  Python libraries used for interacting with Google Compute Engine's APIs and
  functionality.  This package contains the modules for Python 2.x.
 
+Package: python3-google-compute-engine
+Section: python
+Architecture: all
+Depends: ${python3:Depends},
+         ${misc:Depends},
+Description: Python library for Google Compute Engine interaction (Python 3)
+ Python libraries used for interacting with Google Compute Engine's APIs and
+ functionality.  This package contains the modules for Python 3.x.
+
 Package: google-compute-engine-oslogin
 Architecture: any
 Depends: ${shlibs:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

OSLOGIN_DIR=google_compute_engine_oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,python3,systemd --buildsystem=pybuild

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	(cd $(OSLOGIN_DIR)/utils && \
		$(CXX) $(CXXFLAGS) -L../../gtest -o test_runner oslogin_utils_test.cc oslogin_utils.cc -lcurl -ljson-c -lgtest -lpthread && \
		./test_runner && \
		rm test_runner)

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	$(MAKE) -C $(OSLOGIN_DIR) DESTDIR=$(CURDIR)/debian/tmp PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security BIN_INSTALL_PATH=/usr/bin install

override_dh_systemd_start:
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-startup-scripts
	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-shutdown-scripts

override_dh_python3:
	dh_python3
	# We want to split the Python 3 scripts out to the
	# gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python3-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python3-google-compute-engine/usr/bin

override_dh_python2:
	dh_python2
	# We don't want the Python 2 scripts at all
	rm -rf debian/python-google-compute-engine/usr/bin

override_dh_clean:
	rm -rf google_compute_engine.egg-info gtest
	dh_clean

## gce-compute-image-packages 20171019+dfsg1

=== google_compute_engine_oslogin/Makefile ===
--- 
+++ 
@@ -3,8 +3,8 @@
 BASENAME = oslogin
 NAME = google-compute-engine-$(BASENAME)
 MAJOR = 1
-MINOR = 0
-REVISION = 5
+MINOR = 1
+REVISION = 0
 
 NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
 NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2

=== debian/changelog ===
gce-compute-image-packages (20171019+dfsg1-0ubuntu1~17.04.0) zesty; urgency=medium

  [ Balint Reczey ]
  * New upstream version 20171019+dfsg1 (LP: #1726810)
    - Add status option for google_oslogin_control
    - OS Login activation via the accounts daemon
  * Tidy up d/control with the help of cme fix dpkg-control
  * Update symlink to shared library with updated minor version
  * Change package priority to optional from extra
  * Add debhelper token to prerm

  [ Zach Marano from Google Cloud Team ]
  * Depend on chrony | ntp | time-daemon instead of just ntp
  * Move all service activation handling to
    gce-compute-image-packages.{postinst|prerm}
  * Make google-compute-engine depend on google-compute-engine-oslogin

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to zesty.

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 24 Oct 2017 16:35:46 +0200

gce-compute-image-packages (20171006+dfsg1-0ubuntu1) artful; urgency=medium

  * List current packaging repository in debian/control
  * New upstream version 20171006+dfsg1 (LP: #1722356)
    - Fix system hang during VM shutdown
    - JSON parser accepts string types for int64 values
  * Update symlink to shared library with updated patch version

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 09 Oct 2017 19:16:04 +0200

## gce-compute-image-packages 20171025+dfsg1

=== google_compute_engine_oslogin/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 NAME = google-compute-engine-$(BASENAME)
 MAJOR = 1
 MINOR = 1
-REVISION = 0
+REVISION = 1
 
 NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
 NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2

=== debian/changelog ===
gce-compute-image-packages (20171025+dfsg1-0ubuntu1~17.10.0) artful; urgency=medium

  [ Balint Reczey ]
  * New upstream version 20171025+dfsg1 (LP: #1729046)
   - Update set_hostname file name to prevent conflict
   - Add apt config to prevent auto-removal of google-compute-engine
   - Remove logging when checking OS Login status
  * Update symlink to shared library with updated patch version
  * Update packaging for changing set_hostname to google_set_hostname
  * Ship apt config to prevent auto-removal of google-compute-engine

  [ Łukasz 'sil2100' Zemczak ]
  * Backport to artful.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 03 Nov 2017 16:04:54 +0100

gce-compute-image-packages (20171019+dfsg1-0ubuntu1) artful; urgency=medium

  [ Balint Reczey ]
  * New upstream version 20171019+dfsg1 (LP: #1726810)
    - Add status option for google_oslogin_control
    - OS Login activation via the accounts daemon
  * Tidy up d/control with the help of cme fix dpkg-control
  * Update symlink to shared library with updated minor version
  * Change package priority to optional from extra
  * Add debhelper token to prerm

  [ Zach Marano from Google Cloud Team ]
  * Depend on chrony | ntp | time-daemon instead of just ntp
  * Move all service activation handling to
    gce-compute-image-packages.{postinst|prerm}
  * Make google-compute-engine depend on google-compute-engine-oslogin

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 24 Oct 2017 16:35:46 +0200

=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,7 @@
 	$(MAKE) -C $(OSLOGIN_DIR) DESTDIR=$(CURDIR)/debian/tmp PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security BIN_INSTALL_PATH=/usr/bin install
 
 override_dh_systemd_start:
-	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-startup-scripts
-	dh_systemd_start --no-restart-on-upgrade --no-start --name=google-shutdown-scripts
+	# Configured in gce-compute-image-packages.postinst instead.
 
 override_dh_python3:
 	dh_python3

## gce-compute-image-packages 20171129+dfsg1

=== google_compute_engine_oslogin/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 NAME = google-compute-engine-$(BASENAME)
 MAJOR = 1
 MINOR = 1
-REVISION = 1
+REVISION = 2
 
 NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
 NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2
@@ -12,10 +12,13 @@
 PAM_INSTALL_PATH = /lib/security
 AUTHKEYS_INSTALL_PATH = /usr/bin
 
+JSON_INCLUDE_PATH = /usr/include/json-c
+INCLUDE_FLAGS = -I$(JSON_INCLUDE_PATH)
+
 CXX = g++
 CXXFLAGS += -fPIC# -Wall
-PAMFLAGS = $(LDFLAGS) -shared
-NSSFLAGS = $(LDFLAGS) -shared -Wl,-soname,$(NSS_LIBRARY_SONAME)
+PAMFLAGS = $(LDFLAGS) $(INCLUDE_FLAGS) -shared
+NSSFLAGS = $(LDFLAGS) $(INCLUDE_FLAGS) -shared -Wl,-soname,$(NSS_LIBRARY_SONAME)
 
 # UTILS
 UTILS_DIR = utils
@@ -86,10 +89,10 @@
 	$(CXX) $(CXXFLAGS) -c $(PAM_ADMIN_SRC) -o $(PAM_ADMIN_OBJ)
 
 $(AUTHKEYS_BIN): $(AUTHKEYS_SRC) $(UTILS_SRC)
-	$(CXX) $(LDFLAGS) -o $(AUTHKEYS_BIN) $(AUTHKEYS_SRC) $(UTILS_SRC) $(LIBS)
+	$(CXX) $(LDFLAGS) $(INCLUDE_FLAGS) -o $(AUTHKEYS_BIN) $(AUTHKEYS_SRC) $(UTILS_SRC) $(LIBS)
 
 $(UTILS): $(UTILS_SRC)
-	$(CXX) $(CXXFLAGS) -c $(UTILS_SRC) -o $(UTILS)
+	$(CXX) $(CXXFLAGS) $(INCLUDE_FLAGS) -c $(UTILS_SRC) -o $(UTILS)
 
 $(SELINUX_MOD_FILE): $(SELINUX_MODULE_SRC)
 	checkmodule -M -m -o $(SELINUX_MOD_FILE) $(SELINUX_MODULE_SRC)

=== debian/changelog ===
gce-compute-image-packages (20171129+dfsg1-0ubuntu1~14.04.0) trusty; urgency=medium

  [ Balint Reczey ]
  * Add minimal debian/google-compute-engine-oslogin.prerm to fix upgrades
    (LP: #1733878)
  * New upstream version 20171129+dfsg1
    - Generate SSH host keys when none are present.
    - Improve logging when activating OS Login.
    - Fix parsing logic for expiration time on SSH public keys.
    - Fix home directory creation PAM config.
  * Update symlink to shared library with updated revision
  * Use -I/usr/include/json-c for building tests
  * Backport to Trusty (LP: #1735793)
    - Retain the delta between devel and trusty as those are necessary for the
      package to build and work.
    - Revert adding systemd as valid ntp daemon

  [ Ludovic Gasc ]
  * Add systemd as valid ntp daemon

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 05 Dec 2017 14:16:22 +0100

gce-compute-image-packages (20171025+dfsg1-0ubuntu1) bionic; urgency=medium

  * New upstream version 20171025+dfsg1 (LP: #1729046)
   - Update set_hostname file name to prevent conflict
   - Add apt config to prevent auto-removal of google-compute-engine
   - Remove logging when checking OS Login status
  * Update symlink to shared library with updated patch version
  * Update packaging for changing set_hostname to google_set_hostname
  * Ship apt config to prevent auto-removal of google-compute-engine

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 31 Oct 2017 18:23:49 +0100

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

OSLOGIN_DIR=google_compute_engine_oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,systemd --buildsystem=pybuild

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	(cd $(OSLOGIN_DIR)/utils && \
		$(CXX) $(CXXFLAGS) -L../../gtest -o test_runner oslogin_utils_test.cc oslogin_utils.cc -I/usr/include/json-c -lcurl -ljson-c -lgtest -lpthread && \
		./test_runner && \
		rm test_runner)

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	$(MAKE) -C $(OSLOGIN_DIR) DESTDIR=$(CURDIR)/debian/tmp PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security BIN_INSTALL_PATH=/usr/bin install

override_dh_installinit:
	dh_installinit --name=google-startup-scripts --onlyscripts --no-start --no-restart-on-upgrade 
	dh_installinit --name=google-shutdown-scripts --onlyscripts --no-start --no-restart-on-upgrade
	dh_installinit --name=google-shutdown-scripts-block-rsyslog --onlyscripts --no-start --no-restart-on-upgrade

override_dh_clean:
	rm -rf google_compute_engine.egg-info gtest
	dh_clean

override_dh_python2:
	dh_python2
	# We want to split the Python scripts out to the
	# gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python-google-compute-engine/usr/bin

## gce-compute-image-packages 20180129+dfsg1

=== google_compute_engine_oslogin/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 NAME = google-compute-engine-$(BASENAME)
 MAJOR = 1
 MINOR = 1
-REVISION = 2
+REVISION = 4
 
 NSS_LIBRARY_NAME = libnss_$(NAME)-$(MAJOR).$(MINOR).$(REVISION).so
 NSS_LIBRARY_SONAME = libnss_$(BASENAME).so.2

=== debian/changelog ===
gce-compute-image-packages (20180129+dfsg1-0ubuntu3) bionic; urgency=medium

  * Drop the Recommends: on google-cloud-sdk; this is moving to be a snap
    for 18.04 and we don't want to continue pulling in a deprecated deb.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 12 Apr 2018 13:34:48 -0700

gce-compute-image-packages (20180129+dfsg1-0ubuntu2) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:53:40 +0000

gce-compute-image-packages (20180129+dfsg1-0ubuntu1) bionic; urgency=medium

  [ Balint Reczey ]
  * Override false positive maintainer-script-empty Lintian warning
  * Suggest libpam-cracklib instead of recommending it
    libpam-cracklib was not installed on cloud images before due to using
    --no-install-recommends when installing gce-compute-image-packages, but this
    state could have been surprising for users. (LP: #1741989)
  * New upstream version 20180129+dfsg1 (LP: #1746588)
    - Close socket connections when requesting metadata.
    - Change the OS Login uid restriction to allow uid 1000.
    - Improve hostname setting, including restarting rsyslog

  [ Zach Marano from Google Cloud Team ]
  * Update symlink to shared library with updated revision
  * Depend on rsyslog
  * Force IPv4 for Debian apt configs

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 31 Jan 2018 20:14:23 +0100

gce-compute-image-packages (20171129+dfsg1-0ubuntu1) bionic; urgency=medium

  [ Balint Reczey ]
  * Add minimal debian/google-compute-engine-oslogin.prerm to fix upgrades
    (LP: #1733878)
  * New upstream version 20171129+dfsg1
    - Generate SSH host keys when none are present.
    - Improve logging when activating OS Login.
    - Fix parsing logic for expiration time on SSH public keys.
    - Fix home directory creation PAM config.
  * Update symlink to shared library with updated revision
  * Use -I/usr/include/json-c for building tests

  [ Ludovic Gasc ]
  * Add systemd as valid ntp daemon

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 01 Dec 2017 19:40:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gce-compute-image-packages
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Section: admin
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daniel Watkins <daniel.watkins@canonical.com>
+Priority: optional
 Build-Depends: cmake,
                debhelper (>= 9),
                dh-python,
@@ -21,23 +20,25 @@
                python-boto,
                python3-boto
 Standards-Version: 3.9.8
+Vcs-Browser: https://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
+Vcs-Git: git://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
 Homepage: https://github.com/GoogleCloudPlatform/compute-image-packages
-Vcs-Git: git://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
-Vcs-Browser: https://git.launchpad.net/~rbalint/ubuntu/+source/gce-compute-image-packages
+XSBC-Original-Maintainer: Daniel Watkins <daniel.watkins@canonical.com>
 
 Package: gce-compute-image-packages
 Architecture: all
 Depends: python3:any,
          ${python3:Depends},
          ${misc:Depends},
+         google-compute-engine-oslogin,
          python3-google-compute-engine (= ${source:Version}),
-         ntp,
+         chrony | ntp | time-daemon | systemd,
+         rsyslog,
          cloud-init
-Recommends: google-cloud-sdk,
-            libpam-cracklib
+Suggests: libpam-cracklib
 Conflicts: gce-cloud-config,
-        gce-daemon,
-        gce-startup-scripts
+           gce-daemon,
+           gce-startup-scripts
 Replaces: gce-cloud-config,
           gce-daemon,
           gce-startup-scripts
@@ -47,19 +48,19 @@
  to the cloud.
 
 Package: python-google-compute-engine
+Architecture: all
 Section: python
-Architecture: all
 Depends: ${python:Depends},
-         ${misc:Depends},
+         ${misc:Depends}
 Description: Python library for Google Compute Engine interaction
  Python libraries used for interacting with Google Compute Engine's APIs and
  functionality.  This package contains the modules for Python 2.x.
 
 Package: python3-google-compute-engine
+Architecture: all
 Section: python
-Architecture: all
 Depends: ${python3:Depends},
-         ${misc:Depends},
+         ${misc:Depends}
 Description: Python library for Google Compute Engine interaction (Python 3)
  Python libraries used for interacting with Google Compute Engine's APIs and
  functionality.  This package contains the modules for Python 3.x.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=google-compute-engine
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS={dir}/google_compute_engine/

OSLOGIN_DIR=google_compute_engine_oslogin

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2,python3,systemd --buildsystem=pybuild

override_dh_auto_configure:
	cp -r /usr/src/gtest/ ./
	dh_auto_configure

override_dh_auto_test:
	(cd gtest && cmake . && $(MAKE) )
	(cd $(OSLOGIN_DIR)/utils && \
		$(CXX) $(CXXFLAGS) -L../../gtest -o test_runner oslogin_utils_test.cc oslogin_utils.cc -I/usr/include/json-c -lcurl -ljson-c -lgtest -lpthread && \
		./test_runner && \
		rm test_runner)

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(OSLOGIN_DIR) all

override_dh_auto_install:
	dh_auto_install
	$(MAKE) -C $(OSLOGIN_DIR) DESTDIR=$(CURDIR)/debian/tmp PAM_INSTALL_PATH=/lib/$(DEB_HOST_MULTIARCH)/security BIN_INSTALL_PATH=/usr/bin install

override_dh_systemd_start:
	# Configured in gce-compute-image-packages.postinst instead.

override_dh_python3:
	dh_python3
	# We want to split the Python 3 scripts out to the
	# gce-compute-image-packages package
	mkdir -p debian/gce-compute-image-packages/usr/bin/
	mv debian/python3-google-compute-engine/usr/bin/* debian/gce-compute-image-packages/usr/bin/
	rmdir debian/python3-google-compute-engine/usr/bin

override_dh_python2:
	dh_python2
	# We don't want the Python 2 scripts at all
	rm -rf debian/python-google-compute-engine/usr/bin

override_dh_clean:
	rm -rf google_compute_engine.egg-info gtest
	dh_clean

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts=\
compression=xz,\
dversionmangle=s/[-.+~]?(git|snapshot|repack|dfsg)(.*)$//i,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gce-compute-image-packages-$1\.tar\.gz/,\
repack,\
repacksuffix=+dfsg1 \
 https://github.com/GoogleCloudPlatform/compute-image-packages/tags .*/v?(\d\S*)\.tar\.gz
